package test;

/*RectangleTest.java

Test code that tests the Rectangle class

EDIT INSTRUCTIONS:

	1. Change name of class RectangleTest for your model.
		(e.g., if testing class "Stack", rename RectangleTest to StackTest.

	2. Code tests -- add/remove/edit the example tests with
		your test code (your test code may follow the examples closely)

	3. In "run" method, edit tests as appropriate so they call tests
		coded in step #2.

*/

import model.Rectangle;

public class RectangleTest {

	//---------------------------------------
	// Public

	public static void main(String[] args) {
		(new RectangleTest()).run();
	}

	public void run() {
		//run experiments
		this.println("");
		this.basicRun("smokeTest_construct_newRectangle", () -> smokeTest_construct_newRectangle());
		this.basicRun("smokeTest_construct_fromSide", () -> smokeTest_construct_fromSide());
		this.basicRun("smokeTest_construct_fromWidthHeight", () -> smokeTest_construct_fromWidthHeight());
	}

	//---------------------------------------
	//Constructor Smoke Tests

	private void smokeTest_construct_newRectangle() {
		//We will simply test that the constructors run without crashing (without throwing an exception)
		@SuppressWarnings("unused")
		Rectangle rectangle = Rectangle.newRectangle();
		//If we get here, constructor did not "crash", so we pass
		this.println("PASSED");
	}

	private void smokeTest_construct_fromSide() {
		//We will simply test that the constructors run without crashing (without throwing an exception)
		@SuppressWarnings("unused")
		Rectangle rectangle = Rectangle.fromSide(8);
		//If we get here, constructor did not "crash", so we pass
		this.println("PASSED");
	}

	private void smokeTest_construct_fromWidthHeight() {
		//We will simply test that the constructors run without crashing (without throwing an exception)
		@SuppressWarnings("unused")
		Rectangle rectangle = Rectangle.fromWidthHeight(10, 5);
		//If we get here, constructor did not "crash", so we pass
		this.println("PASSED");
	}

	//---------------------------------------
	// Helpers

	private void basicRun(String methodName, BlockClosure testMethod) {
		//we bind so the method is associated with this object
		this.printf("Starting - %s%n", methodName);
		try {
			testMethod.evaluate();
		} catch(Exception ex) {
			this.printf("EXCEPTION OCCURRED in %s -- %s%n", methodName, ex.getMessage());
		}
		this.printf("Finished - %s%n%n", methodName);
	}

	protected void println(Object o) {
		System.out.println(o.toString());
	}

	protected void printf(String template, Object ...args) {
		System.out.printf(template, args);
	}

}

//---------------------------------------------------------
//Helper Interfaces and Classes

@FunctionalInterface
interface BlockClosure {
    void evaluate();
}


